#include "filter.h"

void filter::setImages(DSP2D *iir,DSP2D *iig,DSP2D *iib,DSP2D *oir,DSP2D *oig,DSP2D *oib) {
	input[0]=iir; output[0]=oir; oir->resize(iir->width(),iir->height());
	input[1]=iig; output[1]=oig; oig->resize(iig->width(),iig->height());
	input[2]=iib; output[2]=oib; oib->resize(iib->width(),iib->height());
}

void filter::setKernel(KERNEL2D *r, KERNEL2D *g, KERNEL2D *b) {
	kernel[0]=r;
	kernel[1]=g;
	kernel[2]=b;
}

void filter::run() {
	pixel=0;
	stop_flag=false;
	int w=input[0]->width(), h=input[0]->height(), x=0, y=0;
	do {	++pixel;
		kernel[0]->filter(*input[0],*output[0],x,y);
		kernel[1]->filter(*input[1],*output[1],x,y);
		kernel[2]->filter(*input[2],*output[2],x,y);
		if (++x==w) { ++y; x=0; if (y>=h) stop_flag=true; }
	} while (!stop_flag);

	qApp->lock();
	emit(done());
	qApp->unlock();
}

void filter::stop() {
	stop_flag=true;
}
